---

#------------------------------------------------------------------------------------------------
- name: Create temporary download directory
  become:      true
  become_user: "{{ username }}"
  tempfile:
    state: directory
    suffix: ".kubectl_download"
  register: r_kubectl_download_dir

#------------------------------------------------------------------------------------------------
- name: get url in file to analyse
  become:      true
  become_user: "{{ username }}"
  get_url:
     url:  https://storage.googleapis.com/kubernetes-release/release/stable.txt
     dest: "{{ r_kubectl_download_dir.path }}/url.txt"
  register: r_get_url
  changed_when: no

#------------------------------------------------------------------------------------------------
- name: download latest version of kubectl in the temporary download directory
  vars:
    version: "{{ lookup('file', '{{ r_kubectl_download_dir.path }}/url.txt') }}"
  become:      true
  become_user: "{{ username }}"
  get_url:
    url:     "https://storage.googleapis.com/kubernetes-release/release/{{ version }}/bin/linux/amd64/kubectl"
    dest:    "{{ r_kubectl_download_dir.path }}/kubectl"
  register: r_wget
  when: r_get_url is not failed

#------------------------------------------------------------------------------------------------
- name: copy temporary file in destination
  copy:
     src:  "{{ r_kubectl_download_dir.path }}/kubectl"
     dest: "{{ kubectl_bin_path }}/kubectl"
     remote_src: yes
     owner: 'root'
     group: 'root'
     mode: '0644'
     backup: no
  register: copy
  when: r_wget is not failed

#------------------------------------------------------------------------------------------------
- name: Changing perm
  file: dest="{{ kubectl_bin_path }}/kubectl" mode=a+x
  register: change_perm
  changed_when: not change_perm.failed
  when: copy is not failed


#------------------------------------------------------------------------------------------------
- name: Delete temporary download directory
  become:      true
  become_user: "{{ username }}"
  file:
    path: "{{ r_kubectl_download_dir.path }}"
    state: absent
